package com.zhongshu.reward.server.core.dao;

import com.github.microservice.components.data.mongo.mongo.dao.MongoDao;
import com.zhongshu.reward.client.type.ReceiptsStatus;
import com.zhongshu.reward.server.core.dao.extend.WalletReceiptsDaoExtend;
import com.zhongshu.reward.server.core.domain.WalletReceipts;

import java.util.List;

/**
 * @author wjf
 * @date 2024/8/6
 */
public interface WalletReceiptsDao extends MongoDao<WalletReceipts>, WalletReceiptsDaoExtend {

    List<WalletReceipts> findByWallet_IdAndStatusOrderByCreateTimeDesc(String walletId, ReceiptsStatus status);

    WalletReceipts findTopByOutTradeNo(String outTradeNo);

    WalletReceipts findTop1ById(String id);

    WalletReceipts findTop1ByVipUserRecord_IdAndVipUserRecord_First(String vipUserRecordId, boolean first);

    WalletReceipts findTop1ByVipUserRecord_Id(String vipUserRecordId);

    List<WalletReceipts> findByOutTradeNoAndGoodsIdInAndStatus(String outTradeNo, List<String> goodsIds, ReceiptsStatus status);

}
