package com.zhongshu.reward.server.core.domain;

import com.github.microservice.components.data.mongo.mongo.domain.SuperEntity;
import com.zhongshu.reward.client.type.UserType;
import com.zhongshu.vip.client.model.param.VipUserParam;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.data.mongodb.core.mapping.Document;

/**
 * @author wjf
 * @date 2024/8/9
 */
@Data
@Builder
@Document
@AllArgsConstructor
@NoArgsConstructor
public class InviteRecord extends SuperEntity {

    /**
     * 被邀请人id
     */
    private String userId;

    /**
     * 被邀请用户手机号
     */
    private String phone;

    /**
     * 邀请用户id
     */
    private String inviteUserId;

    /**
     * 用户类型
     */
    private UserType userType;

    private Long registerTime;

}
